#include <bits/stdc++.h>

using namespace std;

int nzd(long long int a, long long int b)
{
    while(b != 0)
    {
        long long int r = b;
        b = a % b;
        a = r;
    }
    return a;
}

int resenje(long long int prih[],long long int odbj[], int N, int M)
{
    long long int period = prih[N-1] - prih[N-2];
    for(int i = N - 2; i > 0; i--)
    {
        period = nzd(period, prih[i] - prih[i-1]);
        if(period == 1)
        {
            if(M > 0)
            {
                return 0;
            }
        }
    }

    int pocetak = prih[0] % period;

    for(int i = 0; i < M; i++)
    {
        if((odbj[i] - pocetak) % period == 0)
        {
            return 0;
        }
    }
    
    return 1;
}


int main()
{
    int T;
    cin >> T;
    for (int t = 0; t < T; t++)
    {
        int N, M;
        cin >> N >> M;
        long long int prih[N];
        long long int odbj[M];
        for(int i = 0; i < N; i++)
        {
            cin >> prih[i];
        }
        for(int i = 0; i < M; i++)
        {
            cin >> odbj[i];
        }
        
        sort(prih, prih + N);
        sort(odbj, odbj + M);
        
        cout << resenje(prih, odbj, N, M) << endl;
    }
    
    return 0;
}